-- D:\DIPLOMARBEIT\VHDL\CODE\CD53_DOWN_8BIT_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Fri Sep 21 23:05:22 2001

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_SIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT CD53_down_8Bit
		PORT (
			enableN : IN  STD_LOGIC;
			clk : IN  STD_LOGIC;
			reset : IN  STD_LOGIC;
			clk_en : IN  STD_LOGIC;
			data : IN  STD_LOGIC_VECTOR (7 DOWNTO 0);
			dout : OUT  STD_LOGIC_VECTOR (7 DOWNTO 0);
			cout : OUT  STD_LOGIC_VECTOR (7 DOWNTO 0);
			cout_t : OUT  STD_LOGIC_VECTOR (7 DOWNTO 0);
			clk_en_out : OUT  STD_LOGIC;
			enableOutN : OUT  STD_LOGIC
		);
	END COMPONENT;

	SIGNAL enableN : STD_LOGIC;
	SIGNAL clk : STD_LOGIC;
	SIGNAL reset : STD_LOGIC;
	SIGNAL clk_en : STD_LOGIC;
	SIGNAL data : STD_LOGIC_VECTOR (7 DOWNTO 0);
	SIGNAL dout : STD_LOGIC_VECTOR (7 DOWNTO 0);
	SIGNAL cout : STD_LOGIC_VECTOR (7 DOWNTO 0);
	SIGNAL cout_t : STD_LOGIC_VECTOR (7 DOWNTO 0);
	SIGNAL clk_en_out : STD_LOGIC;
	SIGNAL enableOutN : STD_LOGIC;

BEGIN
	UUT : CD53_down_8Bit
	PORT MAP (
		enableN => enableN,
		clk => clk,
		reset => reset,
		clk_en => clk_en,
		data => data,
		dout => dout,
		cout => cout,
		cout_t => cout_t,
		clk_en_out => clk_en_out,
		enableOutN => enableOutN
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_dout(
			next_dout : STD_LOGIC_VECTOR (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (dout /= next_dout) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns dout="));
				write(TX_LOC, dout);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_dout);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_cout(
			next_cout : STD_LOGIC_VECTOR (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (cout /= next_cout) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns cout="));
				write(TX_LOC, cout);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_cout);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_clk_en_out(
			next_clk_en_out : STD_LOGIC;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (clk_en_out /= next_clk_en_out) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns clk_en_out="));
				write(TX_LOC, clk_en_out);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_clk_en_out);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_enableOutN(
			next_enableOutN : STD_LOGIC;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (enableOutN /= next_enableOutN) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns enableOutN="));
				write(TX_LOC, enableOutN);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_enableOutN);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_cout_t(
			next_cout_t : STD_LOGIC_VECTOR (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (cout_t /= next_cout_t) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns cout_t="));
				write(TX_LOC, cout_t);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_cout_t);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clk <= transport '0';
		enableN <= transport '1';
		reset <= transport '1';
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("11111111"); --FF
		-- --------------------
		WAIT FOR 5 ns; -- Time=5 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=7 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=35 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=60 ns
		reset <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=65 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=67 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=95 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=120 ns
		enableN <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=125 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=127 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=155 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=180 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=185 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=187 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=215 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=240 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("11110000"); --F0
		-- --------------------
		WAIT FOR 5 ns; -- Time=245 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=247 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=275 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=300 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=305 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=307 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=335 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=360 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("00000000"); --0
		-- --------------------
		WAIT FOR 5 ns; -- Time=365 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=367 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=395 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=420 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=425 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=427 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=455 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=480 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("00000000"); --0
		-- --------------------
		WAIT FOR 5 ns; -- Time=485 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=487 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=515 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=540 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=545 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=547 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=575 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=600 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("10000000"); --80
		-- --------------------
		WAIT FOR 5 ns; -- Time=605 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=607 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=635 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=660 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=665 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=667 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=695 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=720 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("00011110"); --1E
		-- --------------------
		WAIT FOR 5 ns; -- Time=725 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=727 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=755 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=780 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=785 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=787 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=815 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=840 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("00110010"); --32
		-- --------------------
		WAIT FOR 5 ns; -- Time=845 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=847 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=875 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=900 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=905 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=907 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=935 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=960 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("01100110"); --66
		-- --------------------
		WAIT FOR 5 ns; -- Time=965 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=967 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=995 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1020 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1025 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1027 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1055 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1080 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("10110010"); --B2
		-- --------------------
		WAIT FOR 5 ns; -- Time=1085 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1087 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1115 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1140 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1145 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1147 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1175 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1200 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("00000011"); --3
		-- --------------------
		WAIT FOR 5 ns; -- Time=1205 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1207 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1235 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1260 ns
		enableN <= transport '0';
		reset <= transport '0';
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1265 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1267 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1295 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1320 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("11110111"); --F7
		-- --------------------
		WAIT FOR 5 ns; -- Time=1325 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1327 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1355 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1380 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1385 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1387 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1415 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1440 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("11111111"); --FF
		-- --------------------
		WAIT FOR 5 ns; -- Time=1445 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1447 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1475 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1500 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1505 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1507 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1535 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1560 ns
		clk_en <= transport '0';
		data <= transport STD_LOGIC_VECTOR'("00000000"); --0
		-- --------------------
		WAIT FOR 5 ns; -- Time=1565 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1567 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1595 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1620 ns
		enableN <= transport '1';
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1625 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1627 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1655 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1680 ns
		clk_en <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1685 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1687 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1715 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1740 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1745 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1747 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1775 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1800 ns
		clk_en <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1805 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1807 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1835 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1860 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1865 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1867 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1895 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1920 ns
		clk_en <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1925 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1927 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=1955 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=1980 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=1985 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=1987 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2015 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2040 ns
		clk_en <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=2045 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2047 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2075 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2100 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=2105 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2107 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2135 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2160 ns
		clk_en <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=2165 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2167 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2195 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2220 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=2225 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2227 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2255 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2280 ns
		clk_en <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=2285 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2287 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2315 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2340 ns
		clk_en <= transport '1';
		-- --------------------
		WAIT FOR 5 ns; -- Time=2345 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2347 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2375 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2400 ns
		clk_en <= transport '0';
		-- --------------------
		WAIT FOR 5 ns; -- Time=2405 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2407 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2435 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2460 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2465 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2467 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2495 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2520 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2525 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2527 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2555 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2580 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2585 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2587 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2615 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2640 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2645 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2647 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2675 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2700 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2705 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2707 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2735 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2760 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2765 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2767 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2795 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2820 ns
		-- --------------------
		WAIT FOR 5 ns; -- Time=2825 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 2 ns; -- Time=2827 ns
		-- --------------------
		WAIT FOR 28 ns; -- Time=2855 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 25 ns; -- Time=2880 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION CD53_down_8Bit_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END CD53_down_8Bit_cfg;
