library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity ramBlock1024kFlex is
	generic(
		-- Bitwidth is the Bitwidth-1 of the internal arithmetic
		-- If Data is of size 8 BITWIDTH must be 7
		BITWIDTH : INTEGER := 15 );
   Port (  clk : in std_logic;
           we : in std_logic;
           adr : in std_logic_vector(9 downto 0);
           di : in std_logic_vector(BITWIDTH downto 0);
           do : out std_logic_vector(BITWIDTH downto 0));
end ramBlock1024kFlex;

architecture syn of ramBlock1024kFlex is

	type ram_type is array (1023 downto 0)
			of std_logic_vector(BITWIDTH downto 0);
	signal RAM : ram_type;
	signal read_adr : std_logic_vector(9 downto 0);
begin
	process (clk)
	begin
		if (clk'event and clk = '1') then
			if (we = '1') then
				RAM(conv_integer(adr)) <= di;
			end if;
			read_adr <= adr;
		end if;
	end process;
	do <= RAM(conv_integer(read_adr));
end syn;
