-- D:\DIPLOMARBEIT\VHDL\CD53_UP_8BIT\CODE\CD53_UP_8BIT_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Thu Sep 13 13:08:46 2001

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT cd53_up_8Bit
		PORT (
			reset : in  std_logic;
			clk : in  std_logic;
			enablen_in : in  std_logic;
			clk_en_in : in  std_logic;
			data_in : in  std_logic_vector (7 DOWNTO 0);
			data_out : out  std_logic_vector (7 DOWNTO 0);
			clk_en_out : out  std_logic;
			enablen_out : out  std_logic
		);
	END COMPONENT;

	SIGNAL reset : std_logic;
	SIGNAL clk : std_logic;
	SIGNAL enablen_in : std_logic;
	SIGNAL clk_en_in : std_logic;
	SIGNAL data_in : std_logic_vector (7 DOWNTO 0);
	SIGNAL data_out : std_logic_vector (7 DOWNTO 0);
	SIGNAL clk_en_out : std_logic;
	SIGNAL enablen_out : std_logic;

BEGIN
	UUT : cd53_up_8Bit
	PORT MAP (
		reset => reset,
		clk => clk,
		enablen_in => enablen_in,
		clk_en_in => clk_en_in,
		data_in => data_in,
		data_out => data_out,
		clk_en_out => clk_en_out,
		enablen_out => enablen_out
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_data_out(
			next_data_out : std_logic_vector (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (data_out /= next_data_out) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns data_out="));
				write(TX_LOC, data_out);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_data_out);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_clk_en_out(
			next_clk_en_out : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (clk_en_out /= next_clk_en_out) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns clk_en_out="));
				write(TX_LOC, clk_en_out);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_clk_en_out);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_enablen_out(
			next_enablen_out : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (enablen_out /= next_enablen_out) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns enablen_out="));
				write(TX_LOC, enablen_out);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_enablen_out);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clk <= transport '0';
		reset <= transport '1';
		enablen_in <= transport '1';
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("11111000"); --F8
		-- --------------------
		WAIT FOR 20 ns; -- Time=20 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=40 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=70 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=100 ns
		reset <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=200 ns
		enablen_in <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=300 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=400 ns
		clk_en_in <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=500 ns
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("00001111"); --F
		-- --------------------
		WAIT FOR 20 ns; -- Time=520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=600 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=700 ns
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("11111001"); --F9
		-- --------------------
		WAIT FOR 20 ns; -- Time=720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=800 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=900 ns
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("00001111"); --F
		-- --------------------
		WAIT FOR 20 ns; -- Time=920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1200 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1300 ns
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("00100110"); --26
		-- --------------------
		WAIT FOR 20 ns; -- Time=1320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1400 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1500 ns
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("11010010"); --D2
		-- --------------------
		WAIT FOR 20 ns; -- Time=1520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1600 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1700 ns
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("11111000"); --F8
		-- --------------------
		WAIT FOR 20 ns; -- Time=1720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1800 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1900 ns
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("11111010"); --FA
		-- --------------------
		WAIT FOR 20 ns; -- Time=1920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2000 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2100 ns
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("11111011"); --FB
		-- --------------------
		WAIT FOR 20 ns; -- Time=2120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2300 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2400 ns
		enablen_in <= transport '1';
		clk_en_in <= transport '0';
		data_in <= transport std_logic_vector'("11111000"); --F8
		-- --------------------
		WAIT FOR 20 ns; -- Time=2420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2500 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2600 ns
		clk_en_in <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2800 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2900 ns
		clk_en_in <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3000 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3100 ns
		clk_en_in <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3200 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3300 ns
		clk_en_in <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3500 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3600 ns
		clk_en_in <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3800 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3900 ns
		clk_en_in <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4000 ns
		clk_en_in <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4100 ns
		clk_en_in <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4120 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION cd53_up_8Bit_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END cd53_up_8Bit_cfg;
