-- D:\DIPLOMARBEIT\VHDL\WT_MAIN_UD_BLOCK8\CODE\WT_1UP_8_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Sat Sep 15 14:38:16 2001

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT wt_1Up_8
		PORT (
			resetn : in  std_logic;
			clk : in  std_logic;
			trigger : in  std_logic;
			horOffset : in  std_logic_vector (9 DOWNTO 0);
			verOffset : in  std_logic_vector (9 DOWNTO 0);
			h_size : in  std_logic_vector (9 DOWNTO 0);
			v_size : in  std_logic_vector (9 DOWNTO 0);
			pix_adr : out  std_logic_vector (9 DOWNTO 0);
			line_adr : out  std_logic_vector (9 DOWNTO 0);
			data_in : in  std_logic_vector (7 DOWNTO 0);
			data_out : out  std_logic_vector (7 DOWNTO 0);
			write_data : out  std_logic;
			cen : out  std_logic;
			oen : out  std_logic;
			wen : out  std_logic;
			busy : out  std_logic
		);
	END COMPONENT;

	SIGNAL resetn : std_logic;
	SIGNAL clk : std_logic;
	SIGNAL trigger : std_logic;
	SIGNAL horOffset : std_logic_vector (9 DOWNTO 0);
	SIGNAL verOffset : std_logic_vector (9 DOWNTO 0);
	SIGNAL h_size : std_logic_vector (9 DOWNTO 0);
	SIGNAL v_size : std_logic_vector (9 DOWNTO 0);
	SIGNAL pix_adr : std_logic_vector (9 DOWNTO 0);
	SIGNAL line_adr : std_logic_vector (9 DOWNTO 0);
	SIGNAL data_in : std_logic_vector (7 DOWNTO 0);
	SIGNAL data_out : std_logic_vector (7 DOWNTO 0);
	SIGNAL write_data : std_logic;
	SIGNAL cen : std_logic;
	SIGNAL oen : std_logic;
	SIGNAL wen : std_logic;
	SIGNAL busy : std_logic;

BEGIN
	UUT : wt_1Up_8
	PORT MAP (
		resetn => resetn,
		clk => clk,
		trigger => trigger,
		horOffset => horOffset,
		verOffset => verOffset,
		h_size => h_size,
		v_size => v_size,
		pix_adr => pix_adr,
		line_adr => line_adr,
		data_in => data_in,
		data_out => data_out,
		write_data => write_data,
		cen => cen,
		oen => oen,
		wen => wen,
		busy => busy
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_pix_adr(
			next_pix_adr : std_logic_vector (9 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (pix_adr /= next_pix_adr) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns pix_adr="));
				write(TX_LOC, pix_adr);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_pix_adr);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_line_adr(
			next_line_adr : std_logic_vector (9 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (line_adr /= next_line_adr) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns line_adr="));
				write(TX_LOC, line_adr);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_line_adr);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_data_out(
			next_data_out : std_logic_vector (7 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (data_out /= next_data_out) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns data_out="));
				write(TX_LOC, data_out);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_data_out);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_write_data(
			next_write_data : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (write_data /= next_write_data) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns write_data="));
				write(TX_LOC, write_data);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_write_data);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_cen(
			next_cen : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (cen /= next_cen) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns cen="));
				write(TX_LOC, cen);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_cen);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_oen(
			next_oen : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (oen /= next_oen) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns oen="));
				write(TX_LOC, oen);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_oen);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_wen(
			next_wen : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wen /= next_wen) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wen="));
				write(TX_LOC, wen);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wen);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_busy(
			next_busy : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (busy /= next_busy) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns busy="));
				write(TX_LOC, busy);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_busy);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clk <= transport '0';
		resetn <= transport '0';
		trigger <= transport '0';
		horOffset <= transport std_logic_vector'("0000000000"); --0
		verOffset <= transport std_logic_vector'("0000000000"); --0
		h_size <= transport std_logic_vector'("0000001010"); --A
		v_size <= transport std_logic_vector'("0000000010"); --2
		data_in <= transport std_logic_vector'("11111000"); --F8
		-- --------------------
		WAIT FOR 20 ns; -- Time=20 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=40 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=70 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=100 ns
		resetn <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=200 ns
		resetn <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=300 ns
		trigger <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=400 ns
		trigger <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=600 ns
		data_in <= transport std_logic_vector'("00001111"); --F
		-- --------------------
		WAIT FOR 20 ns; -- Time=620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=800 ns
		data_in <= transport std_logic_vector'("11111001"); --F9
		-- --------------------
		WAIT FOR 20 ns; -- Time=820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1000 ns
		data_in <= transport std_logic_vector'("00001111"); --F
		-- --------------------
		WAIT FOR 20 ns; -- Time=1020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1200 ns
		data_in <= transport std_logic_vector'("00100110"); --26
		-- --------------------
		WAIT FOR 20 ns; -- Time=1220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1400 ns
		data_in <= transport std_logic_vector'("11010010"); --D2
		-- --------------------
		WAIT FOR 20 ns; -- Time=1420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1600 ns
		data_in <= transport std_logic_vector'("11111000"); --F8
		-- --------------------
		WAIT FOR 20 ns; -- Time=1620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1800 ns
		data_in <= transport std_logic_vector'("11111010"); --FA
		-- --------------------
		WAIT FOR 20 ns; -- Time=1820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2000 ns
		data_in <= transport std_logic_vector'("11111011"); --FB
		-- --------------------
		WAIT FOR 20 ns; -- Time=2020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2200 ns
		data_in <= transport std_logic_vector'("11111000"); --F8
		-- --------------------
		WAIT FOR 20 ns; -- Time=2220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6300 ns
		resetn <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=7900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=7920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=7940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=7970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=8900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=8920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=8940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=8970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=9900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=9920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=9940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=9970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=10900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=10920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=10940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=10970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=11900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=11920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=11940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=11970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=12900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=12920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=12940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=12970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=13900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=13920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=13940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=13970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=14900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=14920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=14940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=14970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=15900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=15920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=15940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=15970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=16900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=16920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=16940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=16970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=17900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=17920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=17940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=17970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=18900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=18920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=18940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=18970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=19900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=19920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=19940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=19970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=20900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=20920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=20940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=20970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=21900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=21920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=21940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=21970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=22000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=22020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=22040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=22070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=22100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=22120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=22140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=22170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=22200 ns
		resetn <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=22220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=22240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=22270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=22300 ns
		resetn <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=22320 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION wt_1Up_8_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END wt_1Up_8_cfg;
