-- D:\DIPLOMARBEIT\VHDL\WT_MAIN_1\CODE\WT_3LEVEL_TB.VHD
-- VHDL Test Bench created by
-- Visual Software Solution's HDL Bencher 1.02
-- Product info/updates: www.testbench.com
-- Support: support@testbench.com
-- Sales: sales@testbench.com / call (954) 370-9030
-- Mon Sep 10 19:32:56 2001

LIBRARY  IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_ARITH.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;

LIBRARY ieee;
USE IEEE.STD_LOGIC_TEXTIO.ALL;
USE STD.TEXTIO.ALL;

ENTITY testbench IS
END testbench;

ARCHITECTURE testbench_arch OF testbench IS
-- If you get a compiler error on the following line,
-- from the menu do Options->Configuration select VHDL 93
FILE RESULTS: TEXT IS OUT "results.txt";
	COMPONENT wt_3level
		PORT (
			resetn : in  std_logic;
			clk : in  std_logic;
			trigger : in  std_logic;
			horOffset : in  std_logic_vector (9 DOWNTO 0);
			verOffset : in  std_logic_vector (9 DOWNTO 0);
			h_size : in  std_logic_vector (9 DOWNTO 0);
			v_size : in  std_logic_vector (9 DOWNTO 0);
			pix_adr : out  std_logic_vector (9 DOWNTO 0);
			line_adr : out  std_logic_vector (9 DOWNTO 0);
			data_in : in  std_logic_vector (15 DOWNTO 0);
			data_out : out  std_logic_vector (15 DOWNTO 0);
			write_data : out  std_logic;
			cen : out  std_logic;
			oen : out  std_logic;
			wen : out  std_logic;
			busy : out  std_logic
		);
	END COMPONENT;

	SIGNAL resetn : std_logic;
	SIGNAL clk : std_logic;
	SIGNAL trigger : std_logic;
	SIGNAL horOffset : std_logic_vector (9 DOWNTO 0);
	SIGNAL verOffset : std_logic_vector (9 DOWNTO 0);
	SIGNAL h_size : std_logic_vector (9 DOWNTO 0);
	SIGNAL v_size : std_logic_vector (9 DOWNTO 0);
	SIGNAL pix_adr : std_logic_vector (9 DOWNTO 0);
	SIGNAL line_adr : std_logic_vector (9 DOWNTO 0);
	SIGNAL data_in : std_logic_vector (15 DOWNTO 0);
	SIGNAL data_out : std_logic_vector (15 DOWNTO 0);
	SIGNAL write_data : std_logic;
	SIGNAL cen : std_logic;
	SIGNAL oen : std_logic;
	SIGNAL wen : std_logic;
	SIGNAL busy : std_logic;

BEGIN
	UUT : wt_3level
	PORT MAP (
		resetn => resetn,
		clk => clk,
		trigger => trigger,
		horOffset => horOffset,
		verOffset => verOffset,
		h_size => h_size,
		v_size => v_size,
		pix_adr => pix_adr,
		line_adr => line_adr,
		data_in => data_in,
		data_out => data_out,
		write_data => write_data,
		cen => cen,
		oen => oen,
		wen => wen,
		busy => busy
	);

	PROCESS
		VARIABLE TX_OUT : LINE;
		VARIABLE TX_ERROR : INTEGER := 0;

		PROCEDURE CHECK_pix_adr(
			next_pix_adr : std_logic_vector (9 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (pix_adr /= next_pix_adr) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns pix_adr="));
				write(TX_LOC, pix_adr);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_pix_adr);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_line_adr(
			next_line_adr : std_logic_vector (9 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (line_adr /= next_line_adr) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns line_adr="));
				write(TX_LOC, line_adr);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_line_adr);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_cen(
			next_cen : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (cen /= next_cen) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns cen="));
				write(TX_LOC, cen);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_cen);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_oen(
			next_oen : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (oen /= next_oen) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns oen="));
				write(TX_LOC, oen);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_oen);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_wen(
			next_wen : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (wen /= next_wen) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns wen="));
				write(TX_LOC, wen);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_wen);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_busy(
			next_busy : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (busy /= next_busy) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns busy="));
				write(TX_LOC, busy);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_busy);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_data_out(
			next_data_out : std_logic_vector (15 DOWNTO 0);
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (data_out /= next_data_out) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns data_out="));
				write(TX_LOC, data_out);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_data_out);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		PROCEDURE CHECK_write_data(
			next_write_data : std_logic;
			TX_TIME : INTEGER
		) IS
			VARIABLE TX_STR : String(1 to 512);
			VARIABLE TX_LOC : LINE;
		BEGIN
			-- If compiler error ("/=" is ambiguous) occurs in the next line of code
			-- change compiler settings to use explicit declarations only
			IF (write_data /= next_write_data) THEN 
				write(TX_LOC,string'("Error at time="));
				write(TX_LOC, TX_TIME);
				write(TX_LOC,string'("ns write_data="));
				write(TX_LOC, write_data);
				write(TX_LOC, string'(", Expected = "));
				write(TX_LOC, next_write_data);
				write(TX_LOC, string'(" "));
				TX_STR(TX_LOC.all'range) := TX_LOC.all;
				writeline(results, TX_LOC);
				Deallocate(TX_LOC);
				ASSERT (FALSE) REPORT TX_STR SEVERITY ERROR;
				TX_ERROR := TX_ERROR + 1;
			END IF;
		END;

		BEGIN
		-- --------------------
		clk <= transport '0';
		resetn <= transport '0';
		trigger <= transport '0';
		h_size <= transport std_logic_vector'("0000000010"); --2
		v_size <= transport std_logic_vector'("0000000100"); --4
		data_in <= transport std_logic_vector'("0000000011111111"); --FF
		horOffset <= transport std_logic_vector'("0000000000"); --0
		verOffset <= transport std_logic_vector'("0000000000"); --0
		-- --------------------
		WAIT FOR 20 ns; -- Time=20 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=40 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=70 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=200 ns
		resetn <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=300 ns
		resetn <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=400 ns
		trigger <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=500 ns
		trigger <= transport '0';
		-- --------------------
		WAIT FOR 20 ns; -- Time=520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=700 ns
		data_in <= transport std_logic_vector'("0000000011110000"); --F0
		-- --------------------
		WAIT FOR 20 ns; -- Time=720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=900 ns
		data_in <= transport std_logic_vector'("0000000000000000"); --0
		-- --------------------
		WAIT FOR 20 ns; -- Time=920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1100 ns
		data_in <= transport std_logic_vector'("0000000000000000"); --0
		-- --------------------
		WAIT FOR 20 ns; -- Time=1120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1300 ns
		data_in <= transport std_logic_vector'("0000000000011110"); --1E
		-- --------------------
		WAIT FOR 20 ns; -- Time=1320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1500 ns
		data_in <= transport std_logic_vector'("ZZZZZZZZZZZZZZZZ"); --Z
		-- --------------------
		WAIT FOR 20 ns; -- Time=1520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=1900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=1920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=1940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=1970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2100 ns
		data_in <= transport std_logic_vector'("0000000000110010"); --32
		-- --------------------
		WAIT FOR 20 ns; -- Time=2120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2300 ns
		data_in <= transport std_logic_vector'("0000000011101011"); --EB
		-- --------------------
		WAIT FOR 20 ns; -- Time=2320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2500 ns
		data_in <= transport std_logic_vector'("ZZZZZZZZZZZZZZZZ"); --Z
		-- --------------------
		WAIT FOR 20 ns; -- Time=2520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=2900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=2920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=2940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=2970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3100 ns
		data_in <= transport std_logic_vector'("0000000011110111"); --F7
		-- --------------------
		WAIT FOR 20 ns; -- Time=3120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3300 ns
		data_in <= transport std_logic_vector'("0000000011110111"); --F7
		-- --------------------
		WAIT FOR 20 ns; -- Time=3320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3500 ns
		data_in <= transport std_logic_vector'("ZZZZZZZZZZZZZZZZ"); --Z
		-- --------------------
		WAIT FOR 20 ns; -- Time=3520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=3900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=3920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=3940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=3970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4100 ns
		data_in <= transport std_logic_vector'("0000000011111111"); --FF
		-- --------------------
		WAIT FOR 20 ns; -- Time=4120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4300 ns
		data_in <= transport std_logic_vector'("ZZZZZZZZZZZZZZZZ"); --Z
		-- --------------------
		WAIT FOR 20 ns; -- Time=4320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=4900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=4920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=4940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=4970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5600 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5620 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5640 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5670 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5700 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5720 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5740 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5770 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5800 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5820 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5840 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5870 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=5900 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=5920 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=5940 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=5970 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6000 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6020 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6040 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6070 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6100 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6120 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6140 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6170 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6200 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6220 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6240 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6270 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6300 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6320 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6340 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6370 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6400 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6420 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6440 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6470 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6500 ns
		-- --------------------
		WAIT FOR 20 ns; -- Time=6520 ns
		clk <= transport '1';
		-- --------------------
		WAIT FOR 20 ns; -- Time=6540 ns
		-- --------------------
		WAIT FOR 30 ns; -- Time=6570 ns
		clk <= transport '0';
		-- --------------------
		WAIT FOR 30 ns; -- Time=6600 ns
		data_in <= transport std_logic_vector'("0000000010000000"); --80
		-- --------------------
		WAIT FOR 20 ns; -- Time=6620 ns
		-- --------------------

		IF (TX_ERROR = 0) THEN 
			write(TX_OUT,string'("No errors or warnings"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Simulation successful (not a failure).  No problems detected. "
				SEVERITY FAILURE;
		ELSE
			write(TX_OUT, TX_ERROR);
			write(TX_OUT, string'(
				" errors found in simulation"));
			writeline(results, TX_OUT);
			ASSERT (FALSE) REPORT
				"Errors found during simulation"
				SEVERITY FAILURE;
		END IF;
	END PROCESS;
END testbench_arch;

CONFIGURATION wt_3level_cfg OF testbench IS
	FOR testbench_arch
	END FOR;
END wt_3level_cfg;
